#include <WiFi.h>
#include <WiFiUdp.h>
#include "esp_wifi_types.h"

#include "_config.priv.h"

#define UPDATES_ENABLED 1
#define WIFI_INITIALLY_STARTED 0
#define DEBUG 0

// Prod
#define DVIZH_VERH_PIN 4
#define DVIZH_NIZ_PIN 16
#define DVIZH_TRIGGER RISING

// TTGO for test
// #define DVIZH_VERH_PIN 35
// #define DVIZH_NIZ_PIN 0
// #define DVIZH_TRIGGER FALLING

#define SVET_ONOFF_PIN 18
#define SVET_YARK_PIN 19

void triggerWifi();
void action();
