void initSvet();
void DvizhEst();
void DvizhaNet();
void PlavnoVklyuchit();
void PlavnoVyklyuchit();
bool Vklyucheno();
void Vklyuchit();
void Vyklyuchit();
void initLED();
void Yarkost(unsigned long i);
void Enable();
void Disable();
void TaskSveta();
void PropustitRaz();


const unsigned long MAX_YARKOST = 1000; const unsigned long MIN_YARKOST = 500; const int VREMYA_VKL = 2000; const unsigned long VREMYA_SVETA = 10000; const int VREMYA_VYKL = 10000; const byte LEDC_CHANNEL_0 = 0; const int LEDC_RESOLUTION_BITS = 12; const unsigned long MAX_CHANNEL_VALUE = 0xfff-1; const int LEDC_BASE_FREQ = 5000; const int DIFF_YARKOST = int(MAX_YARKOST-MIN_YARKOST); TickType_t loopBlockTime = pdMS_TO_TICKS(1000); TickType_t vyklYarkBlockTime = pdMS_TO_TICKS(VREMYA_VYKL/DIFF_YARKOST); unsigned long yarkost; unsigned long kogdaVyklyuchit; void initSvet() {
	yarkost=MIN_YARKOST; kogdaVyklyuchit=0; initLED(); Vyklyuchit();
}
void DvizhEst() {
	kogdaVyklyuchit=millis()+VREMYA_SVETA; if (DEBUG) { Serial.println("Vkl svet"); } PlavnoVklyuchit();
}
void DvizhaNet() {
	if (kogdaVyklyuchit>millis()) { return; } if (Vklyucheno()) { if (DEBUG) { Serial.println("Vykl"); } PlavnoVyklyuchit(); }
}
void PlavnoVklyuchit() {
	Enable(); for(yarkost=yarkost; yarkost<=MAX_YARKOST; yarkost++) {Yarkost(yarkost); if (DEBUG) { Serial.println(yarkost); } delay(VREMYA_VKL/DIFF_YARKOST);} Vklyuchit();
}
void PlavnoVyklyuchit() {
	int v; for(yarkost=yarkost; yarkost>=MIN_YARKOST; yarkost--) {Yarkost(yarkost); if (DEBUG) { Serial.println(yarkost); } v=ulTaskNotifyTake(0,vyklYarkBlockTime); if (v>0) { DvizhEst(); return; }} Vyklyuchit();
}
bool Vklyucheno() {
	return yarkost>MIN_YARKOST;
}
void Vklyuchit() {
	Yarkost(MAX_YARKOST); Enable();
}
void Vyklyuchit() {
	Yarkost(MIN_YARKOST); Disable();
}
void initLED() {
	ledcSetup(LEDC_CHANNEL_0,LEDC_BASE_FREQ,LEDC_RESOLUTION_BITS); ledcAttachPin(SVET_YARK_PIN,LEDC_CHANNEL_0);
}
void Yarkost(unsigned long i) {
	ledcWrite(LEDC_CHANNEL_0,MAX_CHANNEL_VALUE-i);
}
void Enable() {
	digitalWrite(SVET_ONOFF_PIN,1);
}
void Disable() {
	digitalWrite(SVET_ONOFF_PIN,0);
}
void TaskSveta() {
	int v; PropustitRaz(); while(1) {v=ulTaskNotifyTake(0,loopBlockTime); if (v>0) { DvizhEst(); } else { DvizhaNet(); }}
}
void PropustitRaz() {
	ulTaskNotifyTake(0,loopBlockTime);
}
